<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      size="small"
      :inline="true"
      v-show="showSearch"
      label-width="100px"
    >
      <el-row>
        <el-form-item label="锁具机构编码" prop="locksetCode">
          <el-input
            v-model="queryParams.locksetCode"
            placeholder="请输入锁具机构编码"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>

        <el-form-item label="锁具机构名称" prop="locksetName">
          <el-input
            v-model="queryParams.locksetName"
            placeholder="请输入锁具机构名称"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>

        <el-form-item label="锁具机构类型" prop="locksetTypeName">
          <treeselect
            style="width: 218px"
            v-model="queryParams.locksetTypeId"
            :options="locksetTypeOption"
            :normalizer="normalizer"
            placeholder="选择锁具机构类型"
          />
        </el-form-item>

        <el-form-item style="margin-left: 20px">
          <el-button v-no-more-click
            type="primary"
            icon="el-icon-search"
            size="mini"
            @click="handleQuery"
            >搜索
          </el-button>
          <el-button v-no-more-click icon="el-icon-refresh" size="mini" @click="resetQuery"
            >重置
          </el-button>
        </el-form-item>
      </el-row>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button v-no-more-click
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['mes:hw:lk:add']"
          >新增
        </el-button>
      </el-col>

      <el-col :span="1.5">
        <el-button v-no-more-click
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['mes:hw:lk:batchremove']"
          >批量删除
        </el-button>
      </el-col>
      <right-toolbar
        :showSearch.sync="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="repairList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column
        label="锁具机构编码"
        width="150px"
        align="center"
        prop="locksetCode"
      />
      <el-table-column
        label="锁具机构名称"
        width="180px"
        align="center"
        prop="locksetName"
        :show-overflow-tooltip="true"
      />
      <el-table-column label="锁具机构类型" align="center" prop="locksetTypeName" />
      <el-table-column label="锁具机构NFC" align="center" prop="locksetNfc" />
      <el-table-column label="锁具机构RFID" align="center" prop="locksetRfid" />
      <el-table-column label="物资名称" align="center" prop="materialsName" />
      <el-table-column label="锁具机构型号" align="center" prop="locksetSpec" />
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        width="180"
      >
        <template slot-scope="scope">
          <span>{{ scope.row.createTime }}</span>
        </template>
      </el-table-column>

      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
        fixed="right"
      >
        <template slot-scope="scope">
          <el-button v-no-more-click
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['mes:hw:lk:edit']"
            >编辑
          </el-button>
          <el-button v-no-more-click
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['mes:hw:lk:remove']"
            >删除
          </el-button>
          <!--          <el-button v-no-more-click size="mini" type="text">预览</el-button>-->
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.current"
      :limit.sync="queryParams.size"
      @pagination="getList"
    />

    <!-- 添加或修改设备维修单对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="450px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="锁具机构类型" prop="locksetTypeId">
          <treeselect
            v-model="form.locksetTypeId"
            :options="locksetTypeOption"
            :normalizer="normalizer"
            placeholder="选择锁具机构类型"
          />
        </el-form-item>
        <el-row>
          <el-col :span="15">
            <el-form-item label="锁具机构编码" prop="locksetCode">
              <el-input
                v-model="form.locksetCode"
                placeholder="请输入锁具机构编码"
                style="width: 100%"
              />
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label-width="80">
              <el-switch
                v-model="autoGenFlag"
                active-color="#13ce66"
                active-text="自动生成"
                @change="handleAutoGenChange(autoGenFlag)"
              >
              </el-switch>
            </el-form-item>
          </el-col>
        </el-row>
        <el-form-item label="锁具机构名称" prop="locksetName">
          <el-input v-model="form.locksetName" placeholder="请输入锁具机构名称" />
        </el-form-item>
        <el-form-item label="锁具机构NFC" prop="locksetNfc">
          <el-input v-model="form.locksetNfc" placeholder="请输入锁具机构Nfc" />
        </el-form-item>
        <el-form-item label="锁具机构RFID" prop="locksetRfid" >
          <el-input v-model="form.locksetRfid" placeholder="请输入锁具机构RFID" />
        </el-form-item>
        <el-form-item label="物资名称" prop="materialsId">
          <el-select
            v-model="form.materialsId"
            placeholder="请选择物资名称"
            clearable
            style="width: 100%"
          >
            <el-option
              v-for="dict in this.materialsList"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="锁具机构型号" prop="locksetSpec">
          <el-input v-model="form.locksetSpec" placeholder="请输入锁具机构型号" maxlength="16"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button v-no-more-click type="primary" @click="submitForm">确 定</el-button>
        <el-button v-no-more-click @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listLockAPI,
  addLockAPI,
  updateLockAPI,
  delLockAPI,
  getLockInfoAPI,
} from "@/api/mes/Lock/Lock";
import { listMaterials } from "@/api/mes/material/information";
import { genCode } from "@/api/system/autocode/rule";
import { listLockType } from "@/api/mes/locktype/locktype";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

export default {
  name: "lock",
  dicts: ["hardware_status"],
  components: { Treeselect },
  data() {
    return {
      autoGenFlag: false,
      optType: undefined,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      codes: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 设备维修单表格数据
      repairList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      createTime: "",
      queryParams: {
        current: 1,
        size: 10,
        locksetCode: null,
        locksetName: null,
        locksetNfc: null,
        locksetRfid: null,
        locksetTypeId: undefined,
        materialsId: null,
        locksetTypeName: null,
      },
      queryMaterialParams: {
        current: 1,
        size: -1,
      },
      materialsList: [],
      locksetTypeOption: [],
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        locksetCode: [
          { required: true, message: "锁具机构编码不能为空", trigger: "blur" },
        ],
        locksetName: [
          { required: true, message: "锁具机构名称不能为空", trigger: "blur" },
        ],
        locksetNfc: [
          { required: true, message: "锁具机构NFC不能为空", trigger: "blur" },
        ],
        locksetRfid: [
          { required: true, message: "锁具机构RFID不能为空", trigger: "blur" },
        ],
      },
      // 日期选择
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            },
          },
        ],
      },
      value2: "",
      // 新增状态

      EditId: 0, //修改判断
      cascaderOptions: [], // 转换后的数据
      flatHardwareTypeOption: [], // 用于快速查找
    };
  },
  created() {
    this.getList();
    this.getLockTypeList();
    this.getMaterialList();
  },
  methods: {
    // 格式化日期查询数据
    formatDate(date) {
      if (date && date instanceof Date && !isNaN(date)) {
        // 使用本地时间
        return `${date.getFullYear()}-${String(date.getMonth() + 1).padStart(
          2,
          "0"
        )}-${String(date.getDate()).padStart(2, "0")}`;
      }
      return null;
    },
    getMaterialList() {
      listMaterials(this.queryMaterialParams).then((response) => {
        this.materialsList = response.data.records.map((item) => {
          return {
            value: item.materialsCabinetId,
            label: item.materialsName,
          };
        });

        // console.log(response, this.materialsList, "获取物资信息allList ");
      });
    },

    /** 查询设备维修单列表 */
    getList() {
      this.loading = true;
      // 格式化日期并更新 queryParams
      if (Array.isArray(this.createTime) && this.createTime.length === 2) {
        this.queryParams.startTime = this.formatDate(this.createTime[0]);
        this.queryParams.endTime = this.formatDate(this.createTime[1]);
      }
      // 锁具机构数据
      listLockAPI(this.queryParams).then((response) => {
        this.repairList = response.data.records;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    // 获取锁具机构类型-所有
    getLockTypeList() {
      const data = {
        current: 1,
        size: -1,
      };
      listLockType(data).then((response) => {
        this.locksetTypeOption = this.handleTree(
          response.data.records,
          "locksetTypeId",
          "parentTypeId",
          "children"
        );
        // console.log(this.locksetTypeOption, "this.locksetTypeOption");
      });
    },
    /** 转换部门数据结构 */

    normalizer(node) {
      if (node.children && !node.children.length) {
        delete node.children;
      }
      return {
        id: node.locksetTypeId,
        label: node.locksetTypeName,
        children: node.children,
      };
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        locksetTypeId: null,
        locksetName: null,
        locksetCode: null,
        locksetNfc: null,
        locksetRfid: null,
        materialsId: null,
        locksetTypeName: null,
      };

      this.autoGenFlag = false;
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.current = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.queryParams.locksetCode = "";
      this.queryParams.locksetName = "";
      this.queryParams.locksetTypeId = "";

      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.locksetId);
      this.codes = selection.map((item) => item.locksetCode);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.EditId = null;
      this.title = "新增锁具机构信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.EditId = row.locksetId || this.ids;
      getLockInfoAPI(this.EditId).then((response) => {
        // console.log(response, "编辑拿到单挑数");
        this.form = response.data;
        this.open = true;
        this.title = "编辑锁具机构信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.EditId != null) {
            updateLockAPI(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            // console.log(this.form, "form");
            addLockAPI(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.EditId = null;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const repairIds = row.locksetId || this.ids;
      const repairCodes = row.locksetCode || this.codes;
      this.$modal
        .confirm('是否确认删除编码为"' + repairCodes + '"的数据项？')
        .then(function () {
          return delLockAPI(repairIds);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },

    //自动生成编码
    handleAutoGenChange(autoGenFlag) {
      if (autoGenFlag) {
        genCode("LOCKSET_CODE").then((response) => {
          this.form.locksetCode = response;
        });
      } else {
        this.form.locksetCode = null;
      }
    },
  },
};
</script>
<style scoped>
.imgstatus {
  position: relative;
  top: 1px;
  left: 0px;
}

/deep/ .el-radio__inner {
  border-radius: 2px;
}

/deep/ .el-radio__input.is-checked .el-radio__inner::after {
  content: "";
  width: 8px;
  height: 3px;
  border: 1px solid white;
  border-top: transparent;
  border-right: transparent;
  text-align: center;
  display: block;
  position: absolute;
  top: 3px;
  left: 2px;
  transform: rotate(-45deg);
  border-radius: 0pc;
  background: none;
}
</style>
